/*
adr2ppm.c Version 0.2.0. Email address in PPM
Copyright (C) 2004-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <asm/errno.h>
#include "font.h"

int xlmt,ylmt;
unsigned char *mtx;

void putstx(pgm)
char *pgm;
   {
   fprintf(stderr,"Usage: %s  email_address\n",
      pgm);
   exit(1);
   } /* putstx */

void putimg(str,len)
unsigned char *str;
int len;
   {
   int wrtlen,tot;
   tot = 0;
   while (tot < len)
      {
      wrtlen = write(1,str,len);
      if (wrtlen < 1)
         {
         fprintf(stderr,"Write error %d\n", errno);
         perror("Write error");
         exit(1);
         } /* write err */
      tot += wrtlen;
      } /* write loop */
   } /* putimg */

void wrtppm()
   {
   int len;
   char ascstr[32];
   unsigned char str[32];
   unsigned char *p,*q;
   putimg("P6\n",3);
   sprintf(ascstr,"%d %d\n%d\n",
      xlmt, ylmt, 255);
   len = strlen(ascstr);
   putimg(ascstr,len);
   p = mtx;
   q = mtx + (xlmt * ylmt);
   while (p < q)
      {
      if (*p++)
         {
         str[0] = str[1] = str[2] = 0;
         } /* if black */
      else
         {
         str[0] = str[1] = str[2] = 255;
         } /* else white */
      putimg(str,3);
      } /* for each pixel in mtx */
   } /* wrtppm */

void drawpxl(x,y)
int x,y;
   {
   unsigned char *p;
   if (x < 0 || x >= xlmt)
      {
      fprintf(stderr,"drawpxl: x out of range %d\n", x);
      exit(0);
      return;
      } /* x out of range */
   else if (y < 0 || y >= ylmt)
      {
      fprintf(stderr,"drawpxl: y out of range %d\n", y);
      exit(0);
      return;
      } /* y out of range */
   else
      {
      p = mtx + (y * xlmt) + x;
      *p = 1;
      } /* else draw pixel */
   } /* drawpxl */

void drawtxt(str,x,y)
char *str;
int x,y;
   {
   int len,i,j,k;
   int ofst,row,col;
   char *p,*q;
   len = strlen(str);
   p = str;
   q = p + len;
   ofst = 0;
   while (p < q)
      {
      i = *p - 32;
      row = y;
      for (j=0;j<16;j++)
         {
         col = x + ofst;
         for (k=0;k<8;k++)
            {
            if (col >= (xlmt-8)
               || row >= (ylmt-16))
               {
               fprintf(stderr,"Text overflow "
                  "%c in %d %d\n",
                  *p, col, row);
               return;
               } /* if too far to right */
            if (font[i][j][k])
               drawpxl(col,row);
            col++;
            } /* for each pxl col */
         row++;
         } /* for each pxl row */
      p++;
      ofst += 8;
      } /* for each char in string */
   } /* drawtxt */

void draw(adr)
char *adr;
   {
   drawtxt(adr,10,10);
   wrtppm();
   } /* draw */

int main(argc,argv)
int argc;
char **argv;
   {
   int len;
   char adr[256];
   unsigned char *p,*q;
   if (argc != 2) putstx(*argv);
   len = strlen(*(argv+1));
   if (len > 127)
      {
      fprintf(stderr,"URL too long: %d\n", len);
      putstx(*argv);
      } /* ovfl */
   strcpy(adr,*(argv+1));

   /* width is 8 pixels per char + 2 char at either end */
   /* height is 3 printed rows */
   xlmt = (len * 8) + 32;
   ylmt = 48;
   mtx = (unsigned char *) malloc(xlmt * ylmt);
   p = mtx;
   q = mtx + (ylmt * xlmt);
   while (p < q) *p++ = '\0';

   draw(adr);
   return(0);
   } /* main */
